/**
 * ------ OUT OF USE!!!
 * Class to execute the exhaustive testing method
 * 
 * @author I054742
 *
 */
public class ExhaustiveTesting extends FunctionalityTesting {	
	
	
	boolean execute () {
		
		Loggin.Log(Globals.indent()+"\n#####################################################################");
		Loggin.Log(Globals.indent()+"############ Starting exhaustive tester process... ##################");
		Loggin.Log(Globals.indent()+"#####################################################################\n");
		Globals.incIndent();
		
		try {
			
			this.initialize();
			this.totalEntriesWhereAdding=this.totalEntries=1;
			this.initialEntryCounting(GeneralConfiguration.getStartingPoint());
			this.percentageDeleteEntries=100;
			this.percentageModif=100;
			
			this.maximum = this.calcMaximum(this.maxims);
			
			this.times[Globals.TIME_INDEX_FOR_TESTER] = System.currentTimeMillis();
			return this.tester(GeneralConfiguration.getStartingPoint(),999999999);
		}
		catch (Exception exc) {
			if (Certification.DEBUGGING_INFO) Loggin.Log(Globals.indent()+"Exception: \""+exc.getMessage()+"\" in ExhaustiveTesting.execute");
			return false;
		}
		finally {
			this.times[Globals.TIME_INDEX_FOR_TESTER] = System.currentTimeMillis() - this.times[Globals.TIME_INDEX_FOR_TESTER];
			Globals.decIndent();
			Loggin.Log(Globals.indent()+"\n#####################################################################");
			Loggin.Log(Globals.indent()+"############### Exhaustive tester process ended... ##################");
			Loggin.Log(Globals.indent()+"#####################################################################\n");
		}
	}
	
	
	private boolean launchRepetitions (int[] markAsFalse, int []numbOfOpers, String sp, EntrySet modified, EntrySet newEnts) {
		
		/*int repetitions = numbOfOpers[Globals.DEL_ENTRIES]/(Globals.randGen.nextInt(3)+1);
		boolean allow[] = new boolean[]{true,true,true,true,true};
		this.setAllowed(allow,false,markAsFalse);
		for (int j=0; this.localCondition(numbOfOpers) && j<repetitions; j++) {
			if (this.launchOper(allow,numbOfOpers,modified,sp,null,null,newEnts,false)==false) return false;
		}*/
		return true;
	}
	
	
	private boolean launchDelsAndAdds (boolean deleteAll, boolean addALot, int []numbOfOpers, String sp, EntrySet modified, EntrySet newEnts) {
		
		/*for (int i=0; i<3; i++) {
			if (deleteAll && Globals.randGen.nextInt(100)<33) {
				if (this.launchRepetitions(new int[]{Globals.MODIF_ADD_ATTRS,Globals.MODIF_DEL_ATTRS,Globals.MODIF_REP_ATTRS,Globals.ADD_ENTRIES},
										   numbOfOpers,sp,modified,newEnts)==false) return false;
			}
			if (this.localCondition(numbOfOpers)==false) return true;
			if (addALot && Globals.randGen.nextInt(100)<33) {
				if (this.launchRepetitions(new int[]{Globals.MODIF_ADD_ATTRS,Globals.MODIF_DEL_ATTRS,Globals.MODIF_REP_ATTRS,Globals.DEL_ENTRIES},
						   				   numbOfOpers,sp,modified,newEnts)==false) return false;
			}
		}*/
		return true;
	}
	
	
	private boolean launchModifs (int []numbOfOpers, String sp, EntrySet modified, EntrySet newEnts) {
		
		/*int modifOpers[] = new int[]{Globals.MODIF_ADD_ATTRS,Globals.MODIF_DEL_ATTRS,Globals.MODIF_REP_ATTRS};
		for (int i=0; i<modifOpers.length; i++) {
			int oper = modifOpers[i];
			boolean allow[] = new boolean[]{false,false,false,false,false};
			this.setAllowed(allow,true,new int[]{oper});
			for (modified.startIterator(); this.localCondition(numbOfOpers) && modified.hasNext(); ) {
				Entry ent = modified.next();
				for (int j=0; j<ent.getNumbOfAttrs(); j++) {
					MyAttribute att = ent.getAttributeAt(j);
					if (this.launchOper(allow,numbOfOpers,modified,sp,ent,att,newEnts,false)==false) return false;
				}
			}
		}*/
		return true;
	}
	
	
	
	protected boolean tester (String sp, int deepness) {
		
		/*if (this.timeCondition()==false) return true;
		
		EntrySet modified = this.initUnderSp(sp,true);
		if (modified==null) return true;
		
		EntrySet newEnts = new EntrySet();
		int numbOfOpers[] = this.calcNumbOfOps(modified.getNumbOfEntries());
		boolean allowed[] = {true,true,true,true,true};
		boolean deleteAll = Globals.randGen.nextInt(100)<15;
		if (deleteAll) numbOfOpers[Globals.DEL_ENTRIES] = Math.min(this.maxims[Globals.DEL_ENTRIES] - this.currents[Globals.DEL_ENTRIES],modified.getNumbOfEntries());
		boolean addALot = Globals.randGen.nextInt(100)<15;
		if (addALot) numbOfOpers[Globals.ADD_ENTRIES] = Math.min(this.maxims[Globals.ADD_ENTRIES] - this.currents[Globals.ADD_ENTRIES],modified.getNumbOfEntries());
		numbOfOpers[Globals.MODIF_ADD_ATTRS] = (this.maxims[Globals.MODIF_ADD_ATTRS] - this.currents[Globals.MODIF_ADD_ATTRS])/(Globals.randGen.nextInt(2)+1);
		numbOfOpers[Globals.MODIF_DEL_ATTRS] = (this.maxims[Globals.MODIF_DEL_ATTRS] - this.currents[Globals.MODIF_DEL_ATTRS])/(Globals.randGen.nextInt(2)+1);
		numbOfOpers[Globals.MODIF_REP_ATTRS] = (this.maxims[Globals.MODIF_REP_ATTRS] - this.currents[Globals.MODIF_REP_ATTRS])/(Globals.randGen.nextInt(2)+1); 
		this.setAllowed(allowed,numbOfOpers,sp,modified);
		
		if (this.launchDelsAndAdds(deleteAll,addALot,numbOfOpers,sp,modified,newEnts)==false) return false;
		
		if (this.launchModifs(numbOfOpers,sp,modified,newEnts)==false) return false;
		
		while (this.localCondition(numbOfOpers)) {
			
			boolean auxAllow[] = (boolean[])allowed.clone();
			int repeatOper = this.repeatOpers(auxAllow,numbOfOpers);
			for (int i=0; i<repeatOper; i++) {
				if (this.launchOper(auxAllow,numbOfOpers,modified,sp,null,null,newEnts,false)==false) return false;
			}
			this.setAllowed(allowed,numbOfOpers);
			if (this.launchOper((boolean[])allowed.clone(),numbOfOpers,modified,sp,null,null,newEnts,false)==false) return false;
		}
		
		if (this.launchModifs(numbOfOpers,sp,modified,newEnts)==false) return false;
		
		if (this.launchDelsAndAdds(deleteAll,addALot,numbOfOpers,sp,modified,newEnts)==false) return false;
		
		if (this.launchModifs(numbOfOpers,sp,modified,newEnts)==false) return false;
		
		if (Globals.randGen.nextInt(100)<20 && this.tester(sp,deepness)==false) return false;
		
		int percentCalls = 100;
		for (modified.startIterator(); this.condition() && modified.hasNext(); ) {
			
			Entry ent = modified.next();
			if (Globals.randGen.nextInt(100)>=percentCalls) continue;
			int newDeepness = (newEnts.containsEntry(ent)?Math.min(2,deepness-1):deepness-1);
			if (this.tester(ent.getDn(),newDeepness)==false) return false;
		}
		
		if (this.localCondition(numbOfOpers) && Globals.randGen.nextInt(100)<20) return this.tester(sp,deepness);
		
		if (this.localCondition(numbOfOpers) && sp.equalsIgnoreCase(GeneralConfiguration.getStartingPoint()) && this.condition()) return this.tester(sp,deepness); 
		*/
		return true;
	}
}
